<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <title>Jquery Ajax</title>
    <style>
        body {
            font-size: 12px;
            font-family: arial;
            background: #f4f4f4;
            line-height: 1.5em;
        }

        header {
            background-color: grey;
            padding: 20px;
            text-align: center;
            color: rgb(252, 246, 246);
            margin-bottom: 10px;
        }

        #container {
            width: 90%;
            margin: auto;
            padding: 10px;
        }
    </style>
</head>

<body>
    <header>
        <h1>
            Jquery Example
        </h1>
    </header>
    <div id="container">
        <div id="result">

        </div>

        <div id="theDiv">

        </div>

        <div id="ajaxDiv">

        </div>

        <div>
            <ul id="users"></ul>
        </div>
        <h3>POST</h3>
        <form id="postForm" action="https://jsonplaceholder.typicode.com/posts">
            <input type="text" id="title" placeholder="title">
            <br>
            <textarea placeholder="body" id="body"></textarea>
            <br>
            <input type="submit" value="submit" />
        </form>


    </div>

    <script>
        $(document).ready(function () {
            /*
            //By using load function include test.html 

             $("#result").load("test.html", function(responseTxt,statusTxt,xhr){
               if(statusTxt == "success"){
                  alert("Its fine");  
               }else if(statusTxt == "error"){
                   alert("Error" + xhr.statusTxt);
               }
                });
              */

            // By using Ajax call and add test.html 
            /*       var jqxhr = 
                     $.ajax({
                         url: "/test.html",
                         data: {
                             name: "The name",
                             decs: "The description"
                         }
                     })
                     .done(function(data){
                         
                         $('#theDiv').html(data);
                         console.log(data);
                     })
                     .fail(function(){
                         alert("Error");
                     })
               /*   .always(function(dataOrjqXHR, textStatus, jqXHROrerrorThrown){
                         alert("complete");
                     })


               */
        });

        // similar way but using .get  method   
        /*    $(document).ready(function(){
               $.get('test.html', function(data){
                   console.log(data);
                   $('#result').html(data);
               });


            });  
            */
        // Get method for json call 
        /*
         $.getJSON('users.json',function(data){
             $.each(data, function(i,user){
               $('#users').append('<li>'+ user.firstName+'</li>');
             });
         });
         */

        //Fexible Get request by ajax call and using Json Stringify
        /*
                $(document).ready(function () {
                    var theObject = {p1 : "v1", p2 : "v2"};

                    $.ajax({
                            method: 'GET',
                            url: "https://jsonplaceholder.typicode.com/posts",
                            dataType: 'json',
                            data: JSON.stringify(theObject)
                        })
                        .done(function (data) {
                            console.log(data);
                          $.map(data, function(post, i){
                           //   console.log(theObject.p1);
                             $("#ajaxDiv").append('<h3>'+ data +'</h3>');
                   //          $("#result").append('<h3>'+ post.title+'</h3><p>'+post.body +'</p>');
                          })
                        });
                });

*/

        /*
                        $(document).ready(function(){
                            var theObject = {
                                p1: "v1",
                                p2: "v2"
                            };
                            var jqxhr = 
                            $.ajax({
                          //    url : "test.html",
                              processData: false,
                              type: "GET",
                              data : JSON.stringify(theObject)
                            })
                            .done(function(data){
                                console.log(theObject);
                                $('#ajaxDiv').append('<p>'+ theObject.p1 +'<br>'+ theObject.p2 + '</p>');
                            })
                            .fail(function(){
                                alert("Error");
                            })
                        });
                    
        */
        // post request in jquery in Ajax
        /*
                $(document).ready(function(){
                   $('#postForm').submit(function(e){
                       e.preventDefault();

                       var title = $('#title').val();
                       var body = $('#body').val();
                       var url = $(this).attr('action');

                       $.post(url, {
                           title: title,
                           body: body
                       })
                       .done(function(data){
                           console.log("post saved");
                           console.log(data);
                       });
                   });
                });
        */
        //wrong approach need to work on it because it taking id of the input values
        /*
         $(document).ready(function(){
             $('#postForm').submit(function(e){
              e.preventDefault();
              var title = $('#title').val();
              var body = $('#body').val();
              var url = $(this).attr('action');
             
            $.ajax({
                method: 'POST',
                url: url,
                title: title,
                body: body
                
            })
            .done(function(data){
                console.log("post saved");
               console.log(data);
            })

        });
         });
        */

        // By using post and Process Data how it works with jsp and post request

        /*
          $(document).ready(function(){
             
             var theObject = {p1 : "v1", p2 : "v2"};

             var jqxhr = 
             $.ajax({
                 url: "/train.jsp",
                 processData: false,
                 type: "POST",
                 data: JSON.stringify(theObject)
             })
             .done(function(data){
                 console.log(data);
                 $('#ajaxDiv').html(data);
                 console.log(theObject);
             })
             .fail(function(){
                 alert("Error");
             });
          });
          */

        //getmethod call request parameters and object as parameters
        /*
                $(document).ready(function(){
                    
                 var parameters = {
                     p1 : "value1",
                     p2 :  "value2"
                 };

                 $.get("test.html", parameters)
                 .done(function(data){
                     console.log(data);
                     console.log(parameters);
                     $('#ajaxDiv').html(data);
                     $('#ajaxDiv').append('<p>'+ parameters.p1 +'</p><p>'+ parameters.p1 +'</p>');
                 });

                });

        */
        //error handling 404 error
        /*
                var jqxhr =
                    $.ajax({
                        url: "/training.html",
                    })
                    .done(function (data) { 

                    })
                        .fail(function (jqxhr, textStatus, errorThrown) {
                            if (jqxhr.status == 404) {
                                alert("page not found!");
                            }
            
                    });

        */
        // handling error doubt
        /*
                $(document).ajaxError(function(event, jqxhr, ajaxOptions, errorThrown) {
                var contentType   = jqxhr.getResponseHeader("Content-Type");
                var responseBody  = jqxhr.responseText;

                //do something depending on response headers and response body.

        var jqxhr =
            $.ajax({
                url: "/training.html",
            })
            .done (function(data) { 

            })
            .error(function(data){
        alert('error');
            });

        });

        */

        //Asynchronous function and $Deferred Objects
        /*
                function doAsync(callback) {
                    setTimeout(function () {
                        callback();
                    }, 1000);
                }
        */
        // call doAsyn function
        /*
        doAsync(function(){
          console.log("Executed after a delay");
        });
        */
        /* // Asynchronous2 exmaple with done and fail

                function doAsync2(){
                    var deferredObject = $.Deferred();
                    setTimeout(function(){
                        deferredObject.resolve();
                    });

                    return deferredObject.promise();
                }

                var promise = doAsync2();

                promise.done(function(){
                    console.log("Executed after a delay");
                });

                promise.fail(function(){
                    console.log("Execution is failed");
                });

        */
        // how it works not able to figure out
        /*

                function doAsync3() {
                    var deferredObject = $.Deferred();

                    setTimeout(function () {
                        var randomValue = Math.random();
                        if (randomValue < 1) {
                            deferredObject.resolve();
                        } else {
                            deferredObject.reject();
                        }
                    }, 1000);

                    return deferredObject.promise();
                }

            

        var promise = doAsync3();

            promise.done(function() { console.log("done 1"); } );
            promise.done(function() { console.log("done 2"); } );

            promise.fail(function() { console.log("fail 1"); } );
            promise.fail(function() { console.log("fail 2"); } );

            promise.always(function() { console.log("always 1"); } );
            promise.always(function() { console.log("always 2"); } );

        */


        //resolve error another doubt
        /*
                function doAsync4() {
                    var deferredObject = $.Deferred();

                    setTimeout(function () {
                        var randomValue = Math.random();
                        if (randomValue < 1) {
                            deferredObject.reslove(randomValue, "value2" );
                        } else {
                            deferredObject.reject(randomValue, "errorCode");
                        }
                    }, 1000);
                     
                    return deferredObject;
                }


                doAsync4().done(function(value,value2){
                    console.log("doAsync4 success: "+ value + " : "+ value2);
                })
                .fail(function(value,value2){
                    console.log("doAsync4 fail: "+ value + " : "+ value2);
                })
                .always(function(value,value2){
                    console.log("always4: "+ value + " : "+ value2);
                });
          
          */

          //By using notify method
/*
          function doAsync5() {
    var deferredObject = $.Deferred();
console.log(deferredObject);
    setTimeout(function() { deferredObject.notify(1); }, 1000);
    setTimeout(function() { deferredObject.notify(2); }, 2000);
    setTimeout(function() { deferredObject.notify(3); }, 3000);
    setTimeout(function() { deferredObject.resolve(); }, 4000);

    return deferredObject.promise();
}


doAsync5().progress(function(progressValue) {
    console.log("doAsync5 progress : " + progressValue)
}).done(function () {
    console.log("doAsync5 succeeded. ");
});
*/
    </script>

</body>

</html>